'use strict';

const format = require("./format-flattened-query");

module.exports = function tagQuerySegments(queries) {
	let tagMap = {};
	let currentTag = 0;

	queries.forEach((query) => {
		let stack = [];

		query.forEach((segment) => {
			stack.push(segment);
			let formatted = format(stack);

			if (tagMap[formatted] == null) {
				tagMap[formatted] = currentTag++;
			}

			segment.tag = tagMap[formatted];
		});
	});
}